VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Hexbin sample by Matt Hart - vbhelp@matthart.com"
   ClientHeight    =   5580
   ClientLeft      =   1665
   ClientTop       =   1545
   ClientWidth     =   7155
   Height          =   5985
   Left            =   1605
   LinkTopic       =   "Form1"
   ScaleHeight     =   5580
   ScaleWidth      =   7155
   Top             =   1200
   Width           =   7275
   Begin VB.TextBox txtBin 
      Height          =   2415
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   4
      Top             =   3000
      Width           =   6855
   End
   Begin VB.TextBox txtHex 
      Height          =   2415
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   3
      Top             =   480
      Width           =   6855
   End
   Begin VB.CommandButton cmdLoad 
      Caption         =   "&Load"
      Height          =   315
      Left            =   3360
      TabIndex        =   2
      Top             =   60
      Width           =   1215
   End
   Begin VB.TextBox txtFile 
      Height          =   285
      Left            =   960
      TabIndex        =   1
      Text            =   "c:\autoexec.bat"
      Top             =   60
      Width           =   2235
   End
   Begin VB.Label Label1 
      Caption         =   "Filename:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

' Hexbin sample by Matt Hart - vbhelp@matthart.com
' http://matthart.com
'
' This sample shows how to convert data to hex and binary. If you have
' a file larger than about 20k, a TextBox in Win 95/98 can't hold it,
' although a Win NT TextBox can. You should use a RichTextBox control
' for unlimited size. Also, if you need to process files > 64K, then you
' should not input it all at once (into aText) as this sample does, you
' should get about a 4K chunk at a time and process it.

Private Sub cmdLoad_Click()
    If Dir$(txtFile.Text) = "" Then MsgBox "File not found.": Exit Sub
    txtHex.Text = ""
    txtBin.Text = ""
    Dim aText As String, b$, t$, h$, k As Long, i As Long, j As Long, l As Long
    Open txtFile.Text For Binary As 1
    If LOF(1) > 20& * 1024& Then
        If MsgBox("File may be too big. Continue anyway?", vbYesNo) = vbNo Then Close 1: Exit Sub
    End If
    aText = Space$(LOF(1))
    Get 1, , aText
    Close 1
    For k = 1 To Len(aText) + 16 - (Len(aText) Mod 16) Step 16
        txtHex.SelStart = Len(txtHex.Text)
        txtBin.SelStart = Len(txtBin.Text)
        If k > 1 Then
            txtHex.SelText = vbCrLf
            txtHex.SelStart = Len(txtHex.Text)
            txtBin.SelText = vbCrLf
            txtBin.SelStart = Len(txtBin.Text)
        End If
        t$ = Hex$(k - 1): If Len(t$) < 4 Then t$ = String$(4 - Len(t$), "0") & t$
        t$ = t$ & "   "
        For i = k To k + 15
            h$ = "00"
            If i <= Len(aText) Then
                j = Asc(Mid$(aText, i, 1))
                h$ = Hex$(j)
                If Len(h$) < 2 Then h$ = "0" & h$
            End If
            t$ = t$ & "  " & h$
        Next
        txtHex.SelText = t$
        t$ = ""
        For i = k To k + 15
            b$ = "00000000"
            If i <= Len(aText) Then
                b$ = ""
                j = Asc(Mid$(aText, i, 1))
                For l = 0 To 7
                    If (2 ^ l) And j Then b$ = "1" & b$ Else b$ = "0" & b$
                Next
            End If
            t$ = t$ & "  " & b$
        Next
        txtBin.SelText = t$
    Next
End Sub
